/*
 * dar - 'Drawable' Archiver / WinGL
 *
 *  DOS version(DOS/4GW) / Win32 Console Version
 * copyright (C)1995 A.Koizuka/Bio_100%
 *
 * 0.10 koizuka
 *      Eodart@ĆApbg̊eGgɂāA
 *        rgbReserved 0xffȂ΁Aۂɂ͎gĂȂFłB
 *        Ȃ킿AdarKɐF߂́B
 * 0.11 koizuka
 *      EbfOffBits悤ɂ(Photoshopō쐬bmpǂ߂Ȃ)
 *      E*(r,g,b)\ǉBFRGBlŎw肷B
 *      EeotcolortB[hǉB
 *      E*HalftoneiߒǉB95-11-2
 *      Ehalftone, 16F,2FBMPΉB95-11-23
 * 0.11 koizuka 95-12-28
 *      E(dar32)RpCWATCOM C 10.5JɕύXB
 *      E*RawiߒǉB
 * 0.11 koizuka 96-1-18
 *      EWin95̔X^eBbNVXepbg蓖Ă珜O
 *      E(dar.exe) large modelDOS/4GWɕύX
 * 0.11a koizuka 96-3-12
 *      E*Palette\ǉ
 * 0.11a koizuka 96-4-19
 *      E*Assign\ǉ
 *
 * $Header: /WinGL/dar32/dar.cpp 3     98/05/28 4:38 Koizuka $
 *
 */

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <malloc.h>
#include <ctype.h>
#include <io.h>
#pragma hdrstop
#include "bfnt.h"

#define COPYRIGHT ": bmp(s) to DAR converter / WinGL L1 0.12 98-04-01 (c)1995-98 A.Koizuka/Bio_100%%"
#define DAR_VERSION 1   /* DAR format version */
#define HEADER_SIZE1 14  /* pattern header size */
#define HEADER_SIZE2 18  /* pattern header size */
#if DAR_VERSION == 1
#define HEADER_SIZE HEADER_SIZE1
#else
#define HEADER_SIZE HEADER_SIZE2
#endif
char DARFILE_ID[5] = {'D','A','R',':','8'};
#pragma pack(1)
struct DAR_FILEHEADER {
	char ID[5];						/* "DAR:8" */
	char Version;					/* DAR_VERSION */
	unsigned short NumPattern;		/* p^[ */
	unsigned long Dummy4 ;			/* 4Œ */
} ;

int verbose = 1;
long TotalBytes = 0L;
FILE * message_handle ;
int bPascal = 0;

#pragma pack(1)

/* Win32 */
#if defined(__DOS__)
# define NAME "DAR(DOS4GW)"
#else
# define NAME "DAR32(Win32)"
#endif

				/* 2oCg̃t@Cւ̏ */
void putw_2byte( int w, FILE * fp ) {
	putc( (unsigned char)(w & 0xff), fp );
	putc( (unsigned char)((w >> 8) & 0xff), fp );
}

#define FPADD(fp,l)			((fp)+(l))
#define _fread(buf,s,n,fp)	fread(buf,s,n,fp)
#define _fwrite(buf,s,n,fp)	fwrite(buf,s,n,fp)
#define _malloc(s)			malloc(s)
#define _free(p)            free(p)

/* from windows.h */
typedef int BOOL;

#define BI_RGB 0

#define MAKELONG(low, high) ((long)(((unsigned)(low)) | (((unsigned long)((unsigned)(high))) << 16)))

#define hmemcpy(d,s,len)    memcpy(d,s,len)

typedef struct tagBITMAPFILEHEADER {
	unsigned short bfType;
	unsigned long bfSize;
	unsigned short bfReserved1;
	unsigned short bfReserved2;
	unsigned long bfOffBits;
} BITMAPFILEHEADER;
typedef BITMAPFILEHEADER  * LPBITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER {
	unsigned long biSize;
	long biWidth;
	long biHeight;
	unsigned short biPlanes;
	unsigned short biBitCount;
	unsigned long biCompression;
	unsigned long biSizeImage;
	long biXPixPerMeter;
	long biYPixPerMeter;
	unsigned long biClrUsed;
	unsigned long biClrImporant;
} BITMAPINFOHEADER;


/* from wing/samples/utils.h */

typedef BITMAPINFOHEADER * PDIB ;

#define WIDTHBYTES(i) ((unsigned)((i+31)&(~31))/8)
#define DibWidth(lpbi) (unsigned)(((BITMAPINFOHEADER *)(lpbi))->biWidth)
#define DibHeight(lpbi) (unsigned)(((BITMAPINFOHEADER *)(lpbi))->biHeight)

#define DibWidthBytesN(lpbi, n) (unsigned)WIDTHBYTES((unsigned)(lpbi)->biWidth * (unsigned)(n))
#define DibWidthBytes(lpbi) DibWidthBytesN(lpbi, (lpbi)->biBitCount)
#define DibColors(lpbi) ((RGBQUAD *)((unsigned char *)(lpbi) + (int)(lpbi)->biSize))
#define DibPtr(lpbi) (void *)(DibColors(lpbi) + (unsigned)(lpbi)->biClrUsed)

/* WinG Halftones.... */

#define HALFTONE_TCOLOR 9
RGBQUAD WinGHalftonePal[256] = {
 {  0,   0,   0, 0}, {  0,   0, 128, 0}, {  0, 128,   0, 0}, {  0, 128, 128, 0},
 {128,   0,   0, 0}, {128,   0, 128, 0}, {128, 128,   0, 0}, {192, 192, 192, 0},
 {192, 220, 192, 0}, {240, 202, 166, 0}, {  4,   4,   4, 0}, {  8,   8,   8, 0},
 { 12,  12,  12, 0}, { 17,  17,  17, 0}, { 22,  22,  22, 0}, { 28,  28,  28, 0},
 { 34,  34,  34, 0}, { 41,  41,  41, 0}, { 85,  85,  85, 0}, { 77,  77,  77, 0},
 { 66,  66,  66, 0}, { 57,  57,  57, 0}, {129, 129, 129, 0}, {  0,   0, 129, 0},
 {  0, 129,   0, 0}, {  0, 129, 129, 0}, {129,   0,   0, 0}, {129,   0, 129, 0},
 {129, 129,   0, 0}, {  0,   0,  51, 0}, {  0,   0, 102, 0}, {  0,   0, 153, 0},
 {  0,   0, 204, 0}, {  0,  51,   0, 0}, {  0,  51,  51, 0}, {  0,  51, 102, 0},
 {  0,  51, 153, 0}, {  0,  51, 204, 0}, {  0,  51, 255, 0}, {  0, 102,   0, 0},
 {  0, 102,  51, 0}, {  0, 102, 102, 0}, {  0, 102, 153, 0}, {  0, 102, 204, 0},
 {  0, 102, 255, 0}, {  0, 153,   0, 0}, {  0, 153,  51, 0}, {  0, 153, 102, 0},
 {  0, 153, 153, 0}, {  0, 153, 204, 0}, {  0, 153, 255, 0}, {  0, 204,   0, 0},
 {  0, 204,  51, 0}, {  0, 204, 102, 0}, {  0, 204, 153, 0}, {  0, 204, 204, 0},
 {  0, 204, 255, 0}, {  0, 255, 102, 0}, {  0, 255, 153, 0}, {  0, 255, 204, 0},
 { 51,   0,   0, 0}, { 51,   0,  51, 0}, { 51,   0, 102, 0}, { 51,   0, 153, 0},
 { 51,   0, 204, 0}, { 51,   0, 255, 0}, { 51,  51,   0, 0}, { 51,  51,  51, 0},
 { 51,  51, 102, 0}, { 51,  51, 153, 0}, { 51,  51, 204, 0}, { 51,  51, 255, 0},
 { 51, 102,   0, 0}, { 51, 102,  51, 0}, { 51, 102, 102, 0}, { 51, 102, 153, 0},
 { 51, 102, 204, 0}, { 51, 102, 255, 0}, { 51, 153,   0, 0}, { 51, 153,  51, 0},
 { 51, 153, 102, 0}, { 51, 153, 153, 0}, { 51, 153, 204, 0}, { 51, 153, 255, 0},
 { 51, 204,   0, 0}, { 51, 204,  51, 0}, { 51, 204, 102, 0}, { 51, 204, 153, 0},
 { 51, 204, 204, 0}, { 51, 204, 255, 0}, { 51, 255,  51, 0}, { 51, 255, 102, 0},
 { 51, 255, 153, 0}, { 51, 255, 204, 0}, { 51, 255, 255, 0}, {102,   0,   0, 0},
 {102,   0,  51, 0}, {102,   0, 102, 0}, {102,   0, 153, 0}, {102,   0, 204, 0},
 {102,   0, 255, 0}, {102,  51,   0, 0}, {102,  51,  51, 0}, {102,  51, 102, 0},
 {102,  51, 153, 0}, {102,  51, 204, 0}, {102,  51, 255, 0}, {102, 102,   0, 0},
 {102, 102,  51, 0}, {102, 102, 102, 0}, {102, 102, 153, 0}, {102, 102, 204, 0},
 {102, 153,   0, 0}, {102, 153,  51, 0}, {102, 153, 102, 0}, {102, 153, 153, 0},
 {102, 153, 204, 0}, {102, 153, 255, 0}, {102, 204,   0, 0}, {102, 204,  51, 0},
 {102, 204, 153, 0}, {102, 204, 204, 0}, {102, 204, 255, 0}, {102, 255,   0, 0},
 {102, 255,  51, 0}, {102, 255, 153, 0}, {102, 255, 204, 0}, {204,   0, 255, 0},
 {255,   0, 204, 0}, {153, 153,   0, 0}, {153,  51, 153, 0}, {153,   0, 153, 0},
 {153,   0, 204, 0}, {153,   0,   0, 0}, {153,  51,  51, 0}, {153,   0, 102, 0},
 {153,  51, 204, 0}, {153,   0, 255, 0}, {153, 102,   0, 0}, {153, 102,  51, 0},
 {153,  51, 102, 0}, {153, 102, 153, 0}, {153, 102, 204, 0}, {153,  51, 255, 0},
 {153, 153,  51, 0}, {153, 153, 102, 0}, {153, 153, 153, 0}, {153, 153, 204, 0},
 {153, 153, 255, 0}, {153, 204,   0, 0}, {153, 204,  51, 0}, {102, 204, 102, 0},
 {153, 204, 153, 0}, {153, 204, 204, 0}, {153, 204, 255, 0}, {153, 255,   0, 0},
 {153, 255,  51, 0}, {153, 204, 102, 0}, {153, 255, 153, 0}, {153, 255, 204, 0},
 {153, 255, 255, 0}, {204,   0,   0, 0}, {153,   0,  51, 0}, {204,   0, 102, 0},
 {204,   0, 153, 0}, {204,   0, 204, 0}, {153,  51,   0, 0}, {204,  51,  51, 0},
 {204,  51, 102, 0}, {204,  51, 153, 0}, {204,  51, 204, 0}, {204,  51, 255, 0},
 {204, 102,   0, 0}, {204, 102,  51, 0}, {153, 102, 102, 0}, {204, 102, 153, 0},
 {204, 102, 204, 0}, {153, 102, 255, 0}, {204, 153,   0, 0}, {204, 153,  51, 0},
 {204, 153, 102, 0}, {204, 153, 153, 0}, {204, 153, 204, 0}, {204, 153, 255, 0},
 {204, 204,   0, 0}, {204, 204,  51, 0}, {204, 204, 102, 0}, {204, 204, 153, 0},
 {204, 204, 204, 0}, {204, 204, 255, 0}, {204, 255,   0, 0}, {204, 255,  51, 0},
 {153, 255, 102, 0}, {204, 255, 153, 0}, {204, 255, 204, 0}, {204, 255, 255, 0},
 {204,   0,  51, 0}, {255,   0, 102, 0}, {255,   0, 153, 0}, {204,  51,   0, 0},
 {255,  51,  51, 0}, {255,  51, 102, 0}, {255,  51, 153, 0}, {255,  51, 204, 0},
 {255,  51, 255, 0}, {255, 102,   0, 0}, {255, 102,  51, 0}, {204, 102, 102, 0},
 {255, 102, 153, 0}, {255, 102, 204, 0}, {204, 102, 255, 0}, {255, 153,   0, 0},
 {255, 153,  51, 0}, {255, 153, 102, 0}, {255, 153, 153, 0}, {255, 153, 204, 0},
 {255, 153, 255, 0}, {255, 204,   0, 0}, {255, 204,  51, 0}, {255, 204, 102, 0},
 {255, 204, 153, 0}, {255, 204, 204, 0}, {255, 204, 255, 0}, {255, 255,  51, 0},
 {204, 255, 102, 0}, {255, 255, 153, 0}, {255, 255, 204, 0}, {102, 102, 255, 0},
 {102, 255, 102, 0}, {102, 255, 255, 0}, {255, 102, 102, 0}, {255, 102, 255, 0},
 {255, 255, 102, 0}, {193, 193, 193, 0}, { 95,  95,  95, 0}, {119, 119, 119, 0},
 {134, 134, 134, 0}, {150, 150, 150, 0}, {203, 203, 203, 0}, {178, 178, 178, 0},
 {215, 215, 215, 0}, {221, 221, 221, 0}, {227, 227, 227, 0}, {234, 234, 234, 0},
 {241, 241, 241, 0}, {248, 248, 248, 0}, {240, 251, 255, 0}, {164, 160, 160, 0},
 {128, 128, 128, 0}, {  0,   0, 255, 0}, {  0, 255,   0, 0}, {  0, 255, 255, 0},
 {255,   0,   0, 0}, {255,   0, 255, 0}, {255, 255,   0, 0}, {255, 255, 255, 0},
};

/*** These tables are defined in httables.c */
extern "C" unsigned char  aDividedBy51Rounded[256];
extern "C" unsigned char  aDividedBy51[256];
extern "C" unsigned char  aModulo51[256];
extern "C" unsigned char  aTimes6[6];
extern "C" unsigned char  aTimes36[6];
extern "C" unsigned char  aHalftone8x8[64];
extern "C" unsigned char  aWinGHalftoneTranslation[216];

char unsigned const aHalftone4x4_16[16] =
{
   0, 8,  2,  10,
  12,  4, 14, 6,
   3, 11,  1,  9,
  15, 7, 13, 5
};

/* */

int NumBitmaps = 0;
int numDefs = 21;
#define MAX_DEFS 257
#define MAX_DEFS_CACHE 1024
static RGBQUAD paletteDefs[MAX_DEFS_CACHE] = {
 /* B    G    R  num */
 {  0,   0,   0,   0},
 {  0,   0, 128,   1},
 {  0, 128,   0,   2},
 {  0, 128, 128,   3},
 {128,   0,   0,   4},
 {128,   0, 128,   5},
 {128, 128,   0,   6},
 {192, 192, 192,   7},
 {192, 220, 192,   8},
 {240, 202, 166,   9},	/* 9ӂ̂ */
 {240, 200, 164,   9},	/*  */
 {240, 251, 255, 246},
 {164, 160, 160, 247},
 {128, 128, 128, 248},
 {  0,   0, 255, 249},
 {  0, 255,   0, 250},
 {  0, 255, 255, 251},
 {255,   0,   0, 252},
 {255,   0, 255, 253},
 {255, 255,   0, 254},
 {255, 255, 255, 255},
};
int palExist[256];
static int palFix = 256;

char TargetDir[256];

struct Size {
	int wid, hei;			/* o^p^[ЂƂ̑Ŝ̑傫 */
	int div_wid, div_hei;
	int widBlank, heiBlank;
	int ox, oy;				/* ʒuVtg */
	int dhei;				/* Ajp^[ЂƂ̍ */
} ;

struct Transparent {
	BOOL use_rgb;    /* TRUEȂrgbgp, FALSEȂpalgp */
	RGBQUAD rgb;
	int pal;
} ;


/* Win954F̔X^eBbNVXepbg蓖Ă珜O */
void paletteDefs_Win95(void) {
	int i;
	for ( i = 0 ; i < numDefs ; ++i ) {
		int pal = paletteDefs[i].rgbReserved ;
		if ( pal == 8 || pal == 9 || pal == 246 || pal == 247 ) {
			paletteDefs[i].rgbRed = paletteDefs[i].rgbGreen = paletteDefs[i].rgbBlue = 0;
		}
	}
}

/* ---------------------------------------- Data Conversion ---- */

/* DIB->DARϊʁE
 * ߂l̓f[^ׂ̂ẴC̈kʂ̂̍ől(oCg)
 *
 * in:
 *   pat->dx         ... data bits ̉(pixel)
 *   pat->dy         ... data bits ̍
 *   pat->widthBytes ... data bits widthbytes
 *   pat->pDibSurface .. data bits̐擪AhX
 */
static
unsigned analyze( unsigned char * src, unsigned width, unsigned height, unsigned widthBytes, unsigned long * temp, int transparentColor, int bps ) {
	unsigned maxoff = 0 ;
	unsigned write_offset_from_left ;
	unsigned x, y ;
	unsigned lenTransp, lenOpaque ;
	BOOL bsolid = 1;

	for ( y = 0 ; y < height ; ++y ) {
		write_offset_from_left = 0 ;
		lenTransp = lenOpaque = 0 ;
		if ( bps == 8 ) {
			for ( x = 0 ; x < width ; ++x ) {
				if ( src[x] == transparentColor ) {
					if ( lenOpaque ) {
						*temp++ = MAKELONG(lenTransp, lenOpaque) ;
						write_offset_from_left += (lenOpaque + 4 + 3) & ~3 ;
						lenTransp = lenOpaque = 0 ;
					}
					++lenTransp ;
					bsolid = 0;
				} else {
					++lenOpaque ;
				}
			}
		} else {
			int byteps = bps / 8;
			for ( x = 0 ; x < width ; ++x ) {
				int pix;
				if ( byteps == 2 ) {
					pix = *(unsigned short *)&src[x * 2];
				} else if ( byteps == 3 ) {
					pix = *(unsigned long *)&src[x * 3] & 0x00FFFFFF;
				} else if ( byteps == 4 ) {
					pix = *(unsigned long *)&src[x * 4];
				}
				if ( pix == transparentColor ) {
					if ( lenOpaque ) {
						*temp++ = MAKELONG(lenTransp, lenOpaque) ;
						write_offset_from_left += (lenOpaque + 4 + 3) & ~3 ;
						lenTransp = lenOpaque = 0 ;
					}
					lenTransp += byteps;
					bsolid = 0;
				} else {
					lenOpaque += byteps ;
				}
			}
		}
		*temp++ = MAKELONG(lenTransp, lenOpaque) ;
		write_offset_from_left += (lenOpaque + 4 + 3) & ~3 ;

		if ( maxoff < write_offset_from_left )
			maxoff = write_offset_from_left ;

		src += widthBytes ;
	} /* for y */
	if ( bsolid ) {
		maxoff = 0;
	}
	return maxoff ;
}

#if DAR_VERSION == 2

#include "analyze2.h"

#else /* DAR_VERSION */

/* DIB->DARϊʁE]()
 */
static
void transfer( unsigned char * src, unsigned width, unsigned height, unsigned widthBytes, unsigned DestLineBytes, unsigned long * temp, FILE * fp ) {
	unsigned offset ;
	unsigned x, y ;
	unsigned lenTransp, lenOpaque ;
	int i;

	for ( y = 0 ; y < height ; ++y ) {
		for ( offset = x = 0 ; x < width ; ) {
			unsigned long d = *temp++ ;
			fwrite( &d, sizeof d, 1, fp );
			lenTransp = (unsigned)(d & 0xffff) ;
			lenOpaque = (unsigned)((d >> 16) & 0xffff);
			offset += 4 ;

			x += lenTransp ;
			if ( lenOpaque ) {
				_fwrite( src + x, lenOpaque, 1, fp );
				i = ((lenOpaque + 3) & ~3) - lenOpaque ;
				while ( i > 0 ) {
					putc( 0, fp );
					--i ;
				}
				offset += (lenOpaque + 3) & ~3 ;
				x += lenOpaque ;
			}
		}

		while ( offset < DestLineBytes ) {
			  putc( 0, fp );
			  ++offset;
		}
		src += widthBytes ;
	} /* for y */
}

/* DIB->DARϊʁE](Ȃ)
 */
static
void transfer_solid( unsigned char * src, unsigned width, unsigned height, unsigned widthBytes, unsigned DestLineBytes, FILE * fp ) {
	unsigned y, o ;
	unsigned long d;

	for ( y = 0 ; y < height ; ++y ) {
		d = MAKELONG(0, width) ;
		fwrite( &d, sizeof d, 1, fp );
		fwrite( src, width, 1, fp );
		o = 4 + width ;
		while ( o < DestLineBytes ) {
			putc( 0, fp );
			++o ;
		}
		src += widthBytes ;
	} /* for y */
}

#endif /* DAR_VERSION */

void free_bitmap( BITMAPINFOHEADER * bmp ) {
	_free(bmp);
}

BITMAPINFOHEADER * read_bitmap( const char * filename, struct Size size, struct Transparent& t, BOOL bHalftone, int zoom, int bps ) {
	FILE * fp;
	static RGBQUAD temppal[256];
	static char filename2[256];
	BITMAPINFOHEADER * bp = 0 ;
	unsigned char * readline = 0, * readp ;
	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;
	char * errmes = 0;
	long imagesize ;
	unsigned wpitch, palsize, tpalsize ;
	unsigned readpitch ;
	char * wp ;
	int use_pal;
	unsigned char w, lowmask, bitmask ;
	int x,y, i ;
	int tRed;
	int ox,xc,yc ;
	int shifts[8];

	if ( bps > 8 ) {
		bHalftone = 1;
	}
	if ( bps != 8 && bps != 16 && bps != 24 && bps != 32 )
		return 0;

	strcpy( filename2, filename );
	fp = fopen( filename2, "rb" ) ;
	if ( !fp ) {
		sprintf(filename2, "%s%s", TargetDir, filename );
		fp = fopen( filename2, "rb" ) ;
		if ( ! fp ) {
			errmes = "could not open";
			goto error;
		}
	}
	if ( fread( &bf, sizeof bf, 1, fp ) != 1 || bf.bfType != *(unsigned short *)"BM"
	 ||  fread( &bi, sizeof bi, 1, fp ) != 1 || bi.biSize < sizeof bi ) {
		errmes = "BMPt@C܂B";
		goto error;
	}
	if ( bi.biPlanes != 1 || !(bi.biBitCount == 8 || bi.biBitCount == 4 || bi.biBitCount == 1 || (bHalftone && bi.biBitCount == 24)) ) {
		errmes = "BMP̐FΏۊOłBΏۂ 2,16,256F(n[tg[1600F)Ɍ܂B";
		goto error;
	}
	if ( bi.biCompression != BI_RGB ) {
		errmes = "kꂽBMP͏ł܂B";
		goto error;
	}
	if ( bi.biSize > sizeof bi ) {
		fseek( fp, bi.biSize - sizeof bi, SEEK_CUR );
	}
	if ( bi.biBitCount <= 8 ) {
		use_pal = 1;
		if ( bi.biClrUsed == 0 || (bi.biClrUsed > (1U << bi.biBitCount)) )
			bi.biClrUsed = (1 << bi.biBitCount) ;
	} else {
		use_pal = 0;
		bi.biClrUsed = 256;
	}
#if 0
fprintf(message_handle, "use_trgb(%d [%d,%d,%d]), t.pal(%d), bHalftone(%d), bits(%d), biClrUsed(%d)\n", t.use_rgb, t.rgb.rgbRed,t.rgb.rgbGreen, t.rgb.rgbBlue, t.pal, bHalftone, bi.biBitCount, bi.biClrUsed);
#endif

	readpitch = WIDTHBYTES(bi.biWidth * bi.biBitCount);
	lowmask = (unsigned char)(8 / bi.biBitCount - 1);
	bitmask = (unsigned char)((1 << bi.biBitCount) - 1);
	if ( !bHalftone ) {
		for ( x = 0 ; x <= lowmask ; ++x ) {
			shifts[x] = (lowmask - x) * bi.biBitCount;
		}
	}

	wpitch = (unsigned)(bi.biWidth * zoom * (bps / 8) + 3) & ~3 ;
	imagesize = wpitch * bi.biHeight * zoom ;
	palsize = (size_t)(bi.biClrUsed * sizeof(RGBQUAD)) ;
	if ( bHalftone ) {
		tpalsize = palsize;
		palsize = 256 * sizeof(RGBQUAD);
		bi.biClrUsed = 256;
	}
	bp = (BITMAPINFOHEADER *)_malloc( (sizeof bi) + palsize + imagesize );
	readline = (unsigned char *)_malloc( readpitch );
	if ( !bp || !readline ) {
		errmes = "Out of memory.";
		goto error;
	}
	memcpy( bp, &bi, sizeof bi );
	bp->biSize = sizeof bi;
	bp->biWidth = bi.biWidth * zoom;
	bp->biHeight = bi.biHeight * zoom;
	bp->biBitCount = (char)bps;
	if ( bHalftone ) {
		if ( use_pal && fread( temppal, tpalsize, 1, fp ) < 1 ) {
			goto eof_error;
		}
		memcpy( (char *)bp + (sizeof bi), WinGHalftonePal, palsize );
	} else {
		if ( fread( (char *)bp + (sizeof bi), palsize, 1, fp ) < 1 ) {
			goto eof_error;
		}
	}

	fseek( fp, bf.bfOffBits, SEEK_SET );
	wp = (char *)bp + (sizeof bi) + palsize ;

	if ( size.wid == 0 ) {
		if ( size.div_wid > 0 )
			size.wid = (int)bp->biWidth / size.div_wid;
		else
			size.wid = (int)bp->biWidth ;
	} else {
		size.wid += size.widBlank ;
	}
	if ( size.hei == 0 ) {
		if ( size.div_hei > 0 )
			size.hei = (int)bp->biHeight / size.div_hei;
		else
			size.hei = (int)bp->biHeight ;
	} else {
		size.hei += size.heiBlank ;
	}

	if ( t.use_rgb == 0 ) {
		tRed = -1;
	} else {
		tRed = t.rgb.rgbRed;
		t.pal = -1;
	}

	if ( bHalftone ) {
		unsigned ry = (unsigned)bi.biHeight * zoom ;
		for ( y = 0 ; y < bi.biHeight ; ++y ) {
			if ( fread( readline, readpitch, 1, fp ) < 1 ) {
				goto eof_error;
			}
			for ( yc = 0 ; yc < zoom ; ++yc ) {
				unsigned Scanline = --ry % size.hei ;
				readp = readline;
				for ( ox = x = 0 ; x < (int)bi.biWidth ; ++x ) {
					int Red,Green,Blue;
					if ( use_pal ) {
						if ( (x & lowmask) == 0) {
							w = *readp++;
						}
						i = (w >> ((lowmask - (x & lowmask)) * bi.biBitCount)) & bitmask;

						if ( bps <= 8 && t.pal == i ) {
							for (xc = 0 ; xc < zoom ; ++xc )
								wp[ox++] = HALFTONE_TCOLOR;
							continue;
						}
						Red = temppal[i].rgbRed ;
						Green = temppal[i].rgbGreen ;
						Blue = temppal[i].rgbBlue ;
					} else {
						Blue  = *readp++;
						Green = *readp++;
						Red   = *readp++;
					}
					if ( bps > 8 ) {
						if ( bps == 16 ) {
							unsigned char RedTemp = (unsigned char)(Red >> 3);
							unsigned char GreenTemp = (unsigned char)(Green >> 3);
							unsigned char BlueTemp = (unsigned char)(Blue >> 3);
							short pix;
							if ( tRed == Red  &&  t.rgb.rgbGreen == Green  &&  t.rgb.rgbBlue == Blue ) {
								pix = (short)((RedTemp << 10) + (GreenTemp << 5) + BlueTemp);
								t.pal = pix;
								for ( xc = 0 ; xc < zoom ; ++xc ) {
									*(short *)&wp[ox] = pix;
									ox += 2;
								}
							} else {
								for ( xc = 0 ; xc < zoom ; ++xc ) {
									int wx = (ox >> 1) % size.wid;
									int w = aHalftone4x4_16[(wx & 3)*4 + (Scanline & 3)] / 2;
									if (RedTemp < 0x1f  &&  (Red & 7) > w )
										RedTemp++;
									if (GreenTemp < 0x1f  &&  (Green & 7) > w )
										GreenTemp++;
									if (BlueTemp < 0x1f  &&  (Blue & 7) > w )
										BlueTemp++; 
									pix = (short)((RedTemp << 10) + (GreenTemp << 5) + BlueTemp);
									*(short *)&wp[ox] = pix;
									ox += 2;
								}
							}
						} else {
							if ( tRed == Red  &&  t.rgb.rgbGreen == Green  &&  t.rgb.rgbBlue == Blue ) {
								t.pal = (Red << 16) + (Green << 8) + (Blue);
							}
							for ( xc = 0 ; xc < zoom ; ++xc ) {
								wp[ox++] = (char)Blue;
								wp[ox++] = (char)Green;
								wp[ox++] = (char)Red;
								if ( bps == 32 )
									wp[ox++] = 0;
							}
						}
					} else {
						if ( tRed == Red  &&  t.rgb.rgbGreen == Green  &&  t.rgb.rgbBlue == Blue ) {
							for (xc = 0 ; xc < zoom ; ++xc )
								wp[ox++] = HALFTONE_TCOLOR;
						} else {
							for ( xc = 0 ; xc < zoom ; ++xc ) {
								int wx = ox % size.wid;
								unsigned char RedTemp = (unsigned char)(aDividedBy51[Red] + (aModulo51[Red] > aHalftone8x8[(wx % 8)*8 + Scanline%8]));
								unsigned char GreenTemp = (unsigned char)(aDividedBy51[(unsigned char)Green] + (aModulo51[Green] > aHalftone8x8[ (wx % 8)*8 + Scanline%8]));
								unsigned char BlueTemp = (unsigned char)(aDividedBy51[(unsigned char)Blue] + (aModulo51[Blue] > aHalftone8x8[ (wx % 8)*8 + Scanline%8]));

								unsigned char PaletteIndex = (unsigned char)(RedTemp + aTimes6[GreenTemp] + aTimes36[BlueTemp]);

								wp[ox++] = aWinGHalftoneTranslation[PaletteIndex] ;
							}
						}
					}
				} /* for x */
				wp = FPADD(wp, wpitch);
			} /* for yc */
		} /* for y */
	} else {
		if ( bi.biBitCount == 8 && zoom == 1 ) {
			if ( _fread( wp, imagesize, 1, fp ) < 1 ) {
				goto eof_error;
			}
		} else {
			/* 256F256F */
			for ( y = 0 ; y < bi.biHeight ; ++y ) {
				if ( fread( readline, readpitch, 1, fp ) < 1 ) {
					goto eof_error;
				}
				for ( yc = 0 ; yc < zoom ; ++yc ) {
					readp = readline;
					for ( ox = x = 0 ; x < (int)bi.biWidth ; ++x ) {
						if ( (x & lowmask) == 0) {
							w = *readp++;
						}
						for ( xc = 0 ; xc < zoom ; ++xc ) {
							wp[ox++] = (unsigned char)(w >> shifts[x & lowmask]) & bitmask;
						}
					} /* for x */
					wp = FPADD(wp,wpitch);
				} /* for yc */
			} /* for y */
		}
	}

	goto error;

eof_error:
	errmes = "Unexpect end of file.";
	free_bitmap(bp);
	bp = 0;

error:
	if ( readline )
		_free(readline) ;
	if ( fp )
		fclose(fp);
	if ( errmes ) {
		fprintf(message_handle,  "  " );
		fprintf(message_handle,  errmes, filename2 ) ;
		fprintf(message_handle,  "  Abort.\n" );
	}
	return bp;
}

void write_header( FILE * fp ) {
	struct DAR_FILEHEADER dh;
	static RGBQUAD pal[256];
	int i, j, nd ;
	memcpy( dh.ID, DARFILE_ID, sizeof dh.ID );
	dh.Version = DAR_VERSION;
	dh.NumPattern = (short)NumBitmaps;
#if DAR_VERSION == 2
	dh.Dummy4 = (sizeof dh) + TotalBytes + (sizeof pal);
#else
	dh.Dummy4 = 4;
#endif

	fseek( fp, 0L, 0 ) ;
	fwrite( &dh, sizeof dh, 1, fp ) ;

	nd = numDefs;
	if ( nd >= MAX_DEFS )
		nd = MAX_DEFS;
	for ( i = 0 ; i < 256 ; ++i ) {
		palExist[i] = 0 ;
		for ( j = 0 ; j < nd ; ++j ) {
			if ( i == paletteDefs[j].rgbReserved ) {
				pal[i].rgbRed = paletteDefs[j].rgbRed;
				pal[i].rgbGreen = paletteDefs[j].rgbGreen;
				pal[i].rgbBlue = paletteDefs[j].rgbBlue;
				if ( j >= palFix )
					pal[i].rgbReserved = 0xff;		/* gp}[N */
				else
					pal[i].rgbReserved = 0;			/* gp}[N */
				palExist[i] = 1 ;
				break ;
			}
		}
	}
	fwrite( pal, sizeof pal, 1, fp ) ;
}

void fix_palette(void) {
	palFix = numDefs;
}

int assign_palette( int r, int g, int b, int def ) {
	int i, n ;
	int nd = numDefs;
	if ( nd >= MAX_DEFS_CACHE )
		nd = MAX_DEFS_CACHE;
	r &= 0xff; g &= 0xff; b &= 0xff;

	for ( i = 0 ; i < nd ; ++i ) {
		if ( paletteDefs[i].rgbRed == (unsigned char)r &&
			  paletteDefs[i].rgbGreen == (unsigned char)g &&
			  paletteDefs[i].rgbBlue == (unsigned char)b ) {
			return paletteDefs[i].rgbReserved;
		}
	}
	++numDefs;
	if ( i < MAX_DEFS ) {
		paletteDefs[i].rgbRed = (unsigned char)r ;
		paletteDefs[i].rgbGreen = (unsigned char)g ;
		paletteDefs[i].rgbBlue = (unsigned char)b ;
		n = def;
		if ( palExist[n] ) {
			for ( n = 0 ; n < 256 ; ++n ) {
				if ( !palExist[n] )
					break;
			}
		}
		paletteDefs[i].rgbReserved = (unsigned char)n ;
		palExist[n] = 1;
	} else {
		long min_distance = (r*r + g*g + b*b);
		int min_code = 0;

		for ( n = 1 ; n < MAX_DEFS ; ++n ) {
			int difr = (int)paletteDefs[n].rgbRed - r;
			int difg = (int)paletteDefs[n].rgbGreen - g;
			int difb = (int)paletteDefs[n].rgbBlue - b;
			long dist = difr*difr + difg*difg + difb*difb;
			if ( min_distance > dist ) {
				min_distance = dist;
				min_code = n;
			}
		}

		if ( i < MAX_DEFS_CACHE ) {
			paletteDefs[i].rgbRed = (unsigned char)r ;
			paletteDefs[i].rgbGreen = (unsigned char)g ;
			paletteDefs[i].rgbBlue = (unsigned char)b ;
			paletteDefs[i].rgbReserved = paletteDefs[min_code].rgbReserved ;
		}

		i = min_code;  /* pbgR[ĥ肩 */

		if ( numDefs == MAX_DEFS + 1 ) {
			fprintf( message_handle, "Warning: F̂ňꕔȐFɂȂ܂B\n" ) ;
		}
	}
	return paletteDefs[i].rgbReserved;
}

BOOL assign_halftone(void) {
	int i;
	for ( i = 0 ; i < 256; ++i ) {
		if ( i != 8 && i != 9 && i != 246 && i != 247 )
			if ( assign_palette( WinGHalftonePal[i].rgbRed, WinGHalftonePal[i].rgbGreen, WinGHalftonePal[i].rgbBlue, i ) != i )
				return 0;
	}
	return 1;
}


typedef struct IMAGEINFO IMAGEINFO;
struct IMAGEINFO {
	int bpp;
	RGBQUAD * pal;
	int num_pal;
	unsigned char * image;
	long widthBytes;
	unsigned width;
	unsigned height;
	int index;
};

void write_img_dar( IMAGEINFO * img, struct Size size, struct Transparent t, BOOL bHalftone, BOOL bRaw, int bps, FILE * fp, const char * name ) {
	static unsigned char conv[256];
	unsigned x;
	int i, y;
	unsigned linebytes ;
	unsigned char * wp;
	RGBQUAD * pal = img->pal;
	unsigned char * p = img->image;
	int widthBytes = img->widthBytes;
	unsigned width = img->width;
	unsigned height = img->height;
	unsigned long * temp ;
	int tcolor_ok;
	int coloruse_count = 0;
	int first = NumBitmaps;
	BOOL bFirst = 1;

	if ( bps > 8 ) bHalftone = 1;

	int last_numDefs = numDefs;
	if ( !bHalftone ) {
		/* ĜׂẴsNZāAۂɎgĂFm */
		memset( conv, 0, sizeof conv);
		for ( y = 0 ; (unsigned)y < height ; ++y ) {
			wp = FPADD(p, (long)y * widthBytes) ;
			for ( x = 0 ; x < width ; ++x ) {
				conv[wp[x]] = 1 ;
			}
		}
		/* ̏ */
		if ( t.use_rgb || t.pal >= 0 && t.pal < 256 && conv[t.pal] == 0 ) {
			t.pal = -1;  /* FgĂȂ */
		}

		/* Fϊe[u̍쐬(F̃pbgR[hm) */
		tcolor_ok = 0;
		for ( i = 0 ; i < img->num_pal ; ++i ) {
			if ( conv[i] ) {
				++coloruse_count;
				if ( bRaw ) {
					conv[i] = (unsigned char)i ;
				} else {
					conv[i] = (unsigned char)assign_palette( pal[i].rgbRed, pal[i].rgbGreen, pal[i].rgbBlue, i ) ;
				}
				if ( !tcolor_ok ) {
					if ((t.use_rgb
					 && pal[i].rgbRed == t.rgb.rgbRed
					 && pal[i].rgbGreen == t.rgb.rgbGreen
					 && pal[i].rgbBlue == t.rgb.rgbBlue)
					 || t.pal == i ) {
						t.pal = conv[i] ;
						tcolor_ok = 1;
					}
				}
			}
		}

		/* F̕ϊ */
		for ( y = 0 ; (unsigned)y < height ; ++y ) {
			for ( x = 0 ; x < width ; ++x ) {
				wp = p + (long)y * widthBytes + x ;
				*wp = conv[*wp] ;
			}
		}
	}

	/* TCYȗĂۂ̃TCYg */
	if ( size.wid == 0 )
		if ( size.div_wid > 0 )
			size.wid = width / size.div_wid;
		else
			size.wid = width;
	if ( size.hei == 0 )
		if ( size.div_hei  > 0 )
			size.hei = height / size.div_hei;
		else
			size.hei = height;

	/* ͌ʊi[p */
	temp = (unsigned long *)_malloc( (unsigned long)(size.wid / 2 + 1) * 4 * size.hei ) ;
	if ( !temp ) {
		fprintf( message_handle, "out of memory\n" );
		return;
	}

	if ( size.dhei == 0 ) {
		size.dhei = size.hei;
	} else if ( size.dhei > size.hei ) {
		fprintf( message_handle, "<Div␳ %d>", size.dhei );
		size.dhei = size.hei;
	} else if ( size.hei % size.dhei ) {
		fprintf( message_handle, "<Div] %d> ", size.hei % size.dhei );
	}

	/* w̑傫ɍ݂ȂDARfpɏo͂Ă䂭 */
	int byteps = bps / 8;
	for ( y = 0 ; (unsigned)y < (height + size.heiBlank) / (size.hei + size.heiBlank) ; ++y ) {
		for ( x = 0 ; x < (width + size.widBlank) / (size.wid + size.widBlank) ; ++x ) {
			long l = widthBytes * (height - (long)(y+1) * (size.hei + size.heiBlank) + size.heiBlank) + (long)x * (size.wid + size.widBlank) * byteps ;
			BOOL solid = 0 ;
			int namelen;
			int headerlen ;
#if DAR_VERSION == 2
			long bytes;
#endif
			wp = FPADD(p, l) ;

			if ( t.pal >= 0 ) {
				linebytes = analyze( wp, size.wid, size.hei, widthBytes, temp, t.pal, bps);
				if ( !linebytes ) {
					solid = 1 ;
				}
			} else {
				solid = 1 ;
			}
			if ( solid ) {
				linebytes = (size.wid * bps/8 + 3 + 4) & ~3 ;
			}
			if ( verbose > 1 ) {
				fprintf( message_handle, "width(%u,%u) height(%u/%u,%u) linebytes(%u) patsize(%lu), tcolor(%08Xh) offset(%+d,%+d)\n",
					  size.wid, size.widBlank, size.dhei, size.hei, size.heiBlank, linebytes, (unsigned long)linebytes * size.hei, t.pal, size.ox,size.oy );
			}

			namelen = 0;
			if ( bps > 8 || bFirst && name && name[0] ) {
				namelen = ((strlen(name) + 2) + 3) & ~3;
				bFirst = 0;
			}
			headerlen = HEADER_SIZE + namelen;
			if ( bps > 8 ) {
				headerlen += 4 ;
			}
			if ( headerlen == HEADER_SIZE1 && size.ox == 0 && size.oy == 0 && size.dhei == size.hei ) {
				headerlen -= 4;
			}

			TotalBytes += 2 + headerlen + linebytes * size.hei;

			putw_2byte( headerlen, fp ) ;
			putw_2byte( size.wid, fp ) ;
			putw_2byte( size.hei, fp ) ;
			putw_2byte( linebytes, fp ) ;
			putw_2byte( t.pal, fp );		/* 95-10-27 */
			if ( headerlen >= HEADER_SIZE1 ) {
				putw_2byte( size.ox, fp );
				putw_2byte( size.oy, fp );
				putw_2byte( size.dhei, fp );
				if ( namelen ) {
					int l = strlen(name) + 1;
					putc( namelen, fp );
					fputs( name, fp );
					while ( l < namelen ) { putc( 0, fp ); ++l; }
					if ( bps > 8 ) {
						putc( (char)bps, fp );
						putc( (char)t.rgb.rgbBlue, fp );
						putc( (char)t.rgb.rgbGreen, fp );
						putc( (char)t.rgb.rgbRed, fp );
					}
				}
			} else {
				putw_2byte( 0, fp ); /* dummy */
			}
#if DAR_VERSION == 2
			bytes = analyze2( wp, size.wid, size.hei, widthBytes, temp, t.pal);
			putw_2byte( bytes, fp );
			putw_2byte( (bytes >> 16), fp );
			if ( solid ) {
				transfer_solid2( wp, size.wid, size.hei, widthBytes, fp );
			} else {
				transfer2( wp, size.wid, size.hei, widthBytes, temp, fp );
			}
#else
			if ( solid ) {
				transfer_solid( wp, size.wid * byteps, size.hei, widthBytes, linebytes, fp );
			} else {
				transfer( wp, size.wid * byteps, size.hei, widthBytes, linebytes, temp, fp );
			}
#endif
			++NumBitmaps;
		}
	}
	
	if ( verbose == 1 && img->index == 0 ) {
		if ( first + 1 < NumBitmaps ) {
			fprintf( message_handle, "..#%d", NumBitmaps - 1 );
		}
		fprintf( message_handle, "(%ux%u) ", size.wid, size.hei );
	}
	if ( !bHalftone && verbose > 0 && img->index == 0 ) {
		fprintf( message_handle, "bmpF=%d, VK=%+d, total=%d", coloruse_count, numDefs - last_numDefs, numDefs );
	}
	_free( temp ) ;
}

void write_bmp_dar( BITMAPINFOHEADER * bmp, struct Size size, struct Transparent t, BOOL bHalftone, BOOL bRaw, int bps, FILE * fp, const char * name ) {
	IMAGEINFO img;
	img.bpp = bmp->biBitCount;
	img.pal = DibColors(bmp);
	img.image = (unsigned char *)DibPtr(bmp);
	img.widthBytes = DibWidthBytes(bmp);
	img.width = DibWidth(bmp);
	img.height = DibHeight(bmp);
	img.num_pal = bmp->biClrUsed;
	img.index = 0;
	write_img_dar( &img, size, t, bHalftone, bRaw, bps, fp, name );
}


void usage(void) {
	 fprintf( message_handle, NAME COPYRIGHT "\n"
			"usage: dar [-v] [-o <error file>] <filename>\n" );
	 exit(1);
}

#define SKIPSPACE(p)	while ( *(p) == ' ' || *(p) == '\t' ) { ++(p); }

int str_int( char * * p, int * val ) {
	SKIPSPACE(*p);
	if ( **p >= '0' && **p <= '9' ) {
		*val = 0;
		do {
			*val = *val * 10 + (**p - '0');
			++*p;
		} while ( **p >= '0' && **p <= '9' ) ;
		return 1;
	}
	return 0;
}

int str_signed_int( char * * p, int * val ) {
	int minus = 0;
	SKIPSPACE(*p);
	if ( **p == '+' ) {
		++*p;
	} else if ( **p == '-' ) {
		minus = 1;
		++*p;
	}
	if ( **p >= '0' && **p <= '9' ) {
		*val = 0;
		do {
			*val = *val * 10 + (**p - '0');
			++*p;
		} while ( **p >= '0' && **p <= '9' ) ;
		if ( minus )
			*val = -*val ;
		return 1;
	}
	return 0;
}

/* 96-3-12 ʂDARt@C̃pbg̓ǂݍ
 */
BOOL LoadPaletteFile(const char * filename) {
	FILE * fp;
	struct DAR_FILEHEADER dh;
	RGBQUAD rgb;
	BOOL ok = 0;
	int i;

	fp = fopen(filename, "rb");
	if ( fp ) {
		fread( &dh, sizeof dh, 1, fp );
		if ( memcmp( dh.ID, DARFILE_ID, sizeof dh.ID ) == 0 ) {
			ok = 1;

			/* DARt@Cł */
			for ( i = 0 ; i < 256 ; ++i ) {
				fread( &rgb, sizeof rgb, 1, fp );
				if ( rgb.rgbReserved == 0 /* gp̐Fo^ */ ) {
					if ( i >= 10 && i < (256-10) )
						if ( assign_palette( rgb.rgbRed, rgb.rgbGreen, rgb.rgbBlue, i ) != i )
							ok = 0;
				}
			}
			if ( !ok ) {
				fprintf( message_handle, "Warning: pbgo^ł܂łB*Palette̓p^[OɋLqĂBB\n", filename );
			}
		} else {
			fprintf( message_handle, "Error: '%s'DARt@Cł͂Ȃ̂Ńpbgo^ł܂B\n", filename );
		}
		fclose(fp);
	} else {
		fprintf( message_handle, "Error: '%s'Ƃt@Cǂ߂܂B\n", filename );
	}
	return ok;
}


/* pX疼O𒊏oA啶ɂ defnameɊi[ */
void GetDefNamePart( char * defname, const char * path ) {
	const char * head = path;
	char c;

	/* O𒊏o */
	while ((c = *path++) != '\0' ) {
		if ( c == '\\' || c == ':' ) {
			head = path;
		}
	}
	/* gq̑O܂ł啶ɂĊi[ */
	while ( (c = *head++) != '\0'  &&  c != '.' ) {
		*defname++ = (char)(toupper(c));
	}
	*defname = '\0';

	/* _splitpath( path, NULL, NULL, defname, NULL );
	   strupr(defname);
	 */
}

void GetNamePart( char * name, const char * path ) {
	const char * head = path;
	char * dot;
	char c;

	/* O𒊏o */
	while ((c = *path++) != '\0' ) {
		if ( c == '\\' || c == ':' ) {
			head = path;
		}
	}

	strcpy( name, head );

	/* gq͍폜 */
	dot = strrchr( name, '.' );
	if ( dot ) {
		*dot = '\0';
	}
}

int convert_bfnt( const char * filename, struct Size size, BOOL bHalftone, int zoom, BOOL bRaw, int bps, FILE * wfp, int nodef, FILE * hfp ) {
	FILE * fp;
	static char filename2[256];
	char * errmes = 0;
	unsigned wpitch ;
	unsigned char w ;
	int x,y, i ;
	int ox,xc,yc ;
	BFNT* bf = 0;
	unsigned char * buf = 0;
	int ok = 0;

	if ( bps != 8 ) {
		fprintf( message_handle, "! bfnt͂܂8bitB\n" ); /*  */
		return 0;
	}

	const char * name = filename;
	strcpy( filename2, filename );
	fp = fopen( filename2, "rb" ) ;
	if ( !fp ) {
		sprintf(filename2, "%s%s", TargetDir, filename );
		fp = fopen( filename2, "rb" ) ;
		if ( ! fp ) {
			errmes = "could not open";
			goto error;
		}
	}
	bf = BfntOpenfp( fp, "r" );
	if ( !bf ) {
		fclose(fp);
		errmes = "BFNT+t@C܂B";
		goto error;
	}

	if ( !nodef ) {
		char defname[256];
		GetDefNamePart( defname, filename );
		if ( bPascal ) {
			fprintf( hfp, "  DAR_%s_WIDTH = %u;\n", defname, bf->header.Xdots );
			fprintf( hfp, "  DAR_%s_HEIGHT = %u;\n", defname, bf->header.Ydots );
		} else {
			fprintf( hfp, "#define DAR_%s_WIDTH  %u\n", defname, bf->header.Xdots );
			fprintf( hfp, "#define DAR_%s_HEIGHT %u\n", defname, bf->header.Ydots );
		}
	}

	{
	wpitch = bf->header.Xdots;
	long imagesize = bf->header.Xdots * zoom * bf->header.Ydots * zoom;
	buf = (unsigned char *)malloc( imagesize + bf->header.Xdots );
	unsigned char * readline = buf + imagesize;

	int index = 0;
	while ( !BfntEOF(bf) ) {
		unsigned char * wp = buf;
		if ( bHalftone ) {
			unsigned ry = (unsigned)(bf->header.Ydots) * zoom ;
			for ( y = 0 ; y < bf->header.Ydots ; ++y ) {
				if ( BfntReadLineByte( bf, readline, 0, bf->header.Xdots ) < 1 ) {
					goto eof_error;
				}
				for ( yc = 0 ; yc < zoom ; ++yc ) {
					unsigned Scanline = ry++ % size.hei ;
					unsigned char * readp = readline;
					for ( ox = x = 0 ; x < (int)bf->header.Xdots ; ++x ) {
						int Red,Green,Blue;
						i = *readp++;
						if ( bf->tcolor == i ) {
							for (xc = 0 ; xc < zoom ; ++xc )
								wp[ox++] = HALFTONE_TCOLOR;
							continue;
						}
						Red = bf->pal[i].rgbRed ;
						Green = bf->pal[i].rgbGreen ;
						Blue = bf->pal[i].rgbBlue ;
						for ( xc = 0 ; xc < zoom ; ++xc ) {
							int wx = ox;
							unsigned char RedTemp = (unsigned char)(aDividedBy51[Red] + (aModulo51[Red] > aHalftone8x8[(wx % 8)*8 + Scanline%8]));
							unsigned char GreenTemp = (unsigned char)(aDividedBy51[(unsigned char)Green] + (aModulo51[Green] > aHalftone8x8[ (wx % 8)*8 + Scanline%8]));
							unsigned char BlueTemp = (unsigned char)(aDividedBy51[(unsigned char)Blue] + (aModulo51[Blue] > aHalftone8x8[ (wx % 8)*8 + Scanline%8]));

							unsigned char PaletteIndex = (unsigned char)(RedTemp + aTimes6[GreenTemp] + aTimes36[BlueTemp]);

							wp[ox++] = aWinGHalftoneTranslation[PaletteIndex] ;
						}
					} /* for x */
					wp += wpitch;
				} /* for yc */
			} /* for y */
		} else {
			for ( y = 0 ; y < bf->header.Ydots ; ++y ) {
				if ( BfntReadLineByte( bf, readline, 0, bf->header.Xdots ) < 1 ) {
					goto eof_error;
				}
				for ( yc = 0 ; yc < zoom ; ++yc ) {
					unsigned char * readp = readline;
					for ( ox = x = 0 ; x < (int)bf->header.Xdots ; ++x ) {
						w = *readp++;
						for ( xc = 0 ; xc < zoom ; ++xc ) {
							wp[ox++] = (unsigned char)w;
						}
					} /* for x */
					wp += wpitch;
				} /* for yc */
			} /* for y */
		}
		IMAGEINFO img;
		img.bpp = (bf->header.col & 0x7f) - 1;
		img.pal = bf->pal;
		img.width = bf->header.Xdots;
		img.height = bf->header.Ydots;
		img.image = buf + bf->header.Xdots * (img.height - 1);
		img.widthBytes = -(int)bf->header.Xdots;
		img.num_pal = bf->num_pal;
		img.index = index++;
		size.wid = img.width;
		size.hei = img.height;
		size.div_wid = 0;
		size.div_hei = 0;
		size.widBlank = size.heiBlank = 0;
		size.dhei = img.height;
		struct Transparent t;
		t.use_rgb = 0;
		t.pal = bf->tcolor;
		write_img_dar( &img, size, t, bHalftone, bRaw, bps, wfp, name );
		name = "";
	} // while
	}
	ok = 1;
	goto error;

eof_error:
	errmes = "Unexpect end of file.";
	BfntClose(bf);

error:
	if ( buf )
		_free(buf);
	if ( bf ) BfntClose(bf);
	if ( errmes ) {
		fprintf( message_handle, "  " );
		fprintf( message_handle, errmes, filename2 ) ;
		fprintf( message_handle, "  Abort.\n" );
	}
	return ok;
}

int convert_image(const char * line, struct Size size, struct Transparent t, BOOL bHalftone, int zoom, 
  int nodef, FILE * hfp, BOOL bRaw, int bps, FILE * outfp) {
	static char defname[256+5];
	struct Transparent wt = t;
	BITMAPINFOHEADER * bmp;
	const char * ext = line + strlen(line) - 4;
	if ( strcmpi(ext, ".bmp") == 0 ) {
		bmp = read_bitmap(line, size, t, bHalftone, zoom, bps);
		if ( !bmp ) {
			return 0;
		}
		if ( bHalftone ) {
			if ( bps > 8 ) {
				wt.pal = t.pal;
			} else {
				wt.pal = HALFTONE_TCOLOR;
			}
			wt.use_rgb = 0;
		}
		if ( !nodef ) {
			GetDefNamePart( defname, line );
			int w = (size.wid ? size.wid : (size.div_wid > 0) ? (DibWidth(bmp) / size.div_wid) : DibWidth(bmp)) ;
			int h = (size.hei ? size.hei : (size.div_hei > 0) ? (DibHeight(bmp) / size.div_hei) : DibHeight(bmp));
			if ( bPascal ) {
				fprintf( hfp, "  DAR_%s_WIDTH = %u;\n", defname, w );
				fprintf( hfp, "  DAR_%s_HEIGHT = %u;\n", defname, h );
			} else {
				fprintf( hfp, "#define DAR_%s_WIDTH  %u\n", defname, w );
				fprintf( hfp, "#define DAR_%s_HEIGHT %u\n", defname, h );
			}
		}

		GetNamePart( defname, line );
		write_bmp_dar(bmp, size, wt, bHalftone, bRaw, bps, outfp, defname);
		free_bitmap(bmp);
	} else {
		if ( !convert_bfnt(line, size, bHalftone, zoom, bRaw, bps, outfp, nodef, hfp ) ) {
			return 0;
		}
	}
	return 1;
}

/* r,g,bw𓾂 */
int GetRGB( char **p, RGBQUAD * rgb ) {
	if ( **p == '[' || **p == '(' ) {
		int r = 0, g = 0, b = 0;
		++*p;
		str_int( p, &r ) ;
		SKIPSPACE(*p);
		if ( **p == ',' ) ++*p;
		str_int( p, &g ) ;
		SKIPSPACE(*p);
		if ( **p == ',' ) ++*p;
		str_int( p, &b ) ;
		SKIPSPACE(*p);
		if ( **p == ']' || **p == ')' ) {
			++*p;
		}

		rgb->rgbRed = (char)r;
		rgb->rgbGreen = (char)g;
		rgb->rgbBlue = (char)b;
		return 1;
	}
	return 0;
}

int main(int argc, char *argv[]) {
	FILE * fp;
	FILE * outfp;
	FILE * hfp;
	BOOL bHalftone = 0;
	BOOL bRaw = 0;
	static char drv[_MAX_DRIVE];
	static char dir[_MAX_DIR];
	static char fname[256];
	static char targetpath[_MAX_PATH];
	static char headerfile[_MAX_PATH];
	static char defname[256+5];
	static char line[256];
	int result = 0;
	char * source;
	struct Size size;
	int zoom = 1;
	struct Transparent t;
	t.use_rgb = 0;
	int bps = 8;

	message_handle = stdout;

	memset( &size, 0, sizeof size );
	
	const char * message_out = 0;
	while ( argc > 2 && argv[1][0] == '-' ) {
		char * p = argv[1] + 1;
		switch ( *p ) {
		case 'v':
			if ( *(p + 1) )
				verbose = atoi( p + 1);
			else
				verbose = 2;
			break;

		case 'o':
			if( *(p + 1) ) {
				message_out = p + 1;
			} else {
				message_out = argv[2];
				--argc;
				++argv;
			}
			break;

		case 'p':
			bPascal = 1;
			break;

		default:
			usage();
		}
		--argc;
		++argv;
	}
	if ( message_out ) {
		message_handle = fopen( message_out, "w" );
		if ( !message_handle ) {
			message_handle = stdout;
		}
	}

	if ( argc != 2 ) {
		 usage();
	}
	source = argv[1];
	fp = fopen( source, "r" ) ;
	if ( !fp ) {
		fprintf( message_handle, "file '%s' could not open\n", source );
		usage();
	}
	_splitpath( source, drv, dir, fname, NULL );
	sprintf( targetpath, "%s%s%s.DAR", drv, dir, fname ) ;
	outfp = fopen( targetpath, "wb" ) ;
	if ( !outfp ) {
		fprintf( message_handle, "target file '%s' could not open\n", targetpath ) ;
		usage();
	}

	if ( bPascal ) {
		sprintf( headerfile, "%s%sDAR_%s.pas", drv, dir, fname ) ;
	} else {
		sprintf( headerfile, "%s%s%s.DAH", drv, dir, fname ) ;
	}
	hfp = fopen( headerfile, "w" ) ;
	if ( !hfp) {
		fprintf( message_handle, "headerfile '%s' could not open\n", headerfile ) ;
		usage();
	}
	write_header(outfp);

	strupr(fname);

	sprintf( TargetDir, "%s%s", drv, dir );
	if ( bPascal ) {
		fprintf( hfp,	"(* This file is generated by:\n"
						" * " NAME COPYRIGHT "\n"
						" * ̃t@C͒ڏȂł!\n"
						" *)\n\n" );
		fprintf( hfp,	"Unit DAR_%s;\n"
						"Interface\n"
						"Const\n"
						, fname );
	} else {
		fprintf( hfp,	"/* This file is generated by:\n"
						" * " NAME COPYRIGHT "\n"
						" * ̃t@C͒ڏȂł!\n"
						" */\n\n" );
		fprintf( hfp,  "#ifndef DAR_%s_BASE\n"
					   "# define DAR_%s_BASE 0\n"
					   "#endif\n\n", fname, fname );
	}


	paletteDefs_Win95();

	t.pal = 255 - 10;
	while ( fgets(line, sizeof line, fp) ) {
		int len;
		if ( verbose > 1 ) {
			fprintf( message_handle, "%s", line );
		}

		/* s̋󔒂щs */
		len = strlen(line);
		while ( len > 0 && line[len-1] == '\n' || line[len-1] == ' ' || line[len-1] == '\t' ) {
			line[--len] = '\0';
		}

		if ( line[0]  &&  line[0] != ';' ) {
			if ( line[0] == '*' ) {
				/* ----- n͐l, s͕  []̓p^[1t@Co^邲Ƃɏ
				    *[r,g,b]      FRGBŎw
				    *(r,g,b)      FRGBŎw
				    *n            FpbgR[hnŎw
				    *H            n[tg[pbg[h
				    *R            pbgϊsȂ[h
				    *Zoom n       {n{ɂ
				    *Palette s    pbgt@Csǂݍ
				    *Assign n [r,g,b] s  pbg̒`(Osƒ`Bn͊]ԍBs,nȗ\)
				    *Offset x,y   p^[̑Έʒu [] l0,0
				    *Div y        c̃AjPʃhbg [] l0
				    *Bpp n        bpp(8,16,24,32)
				 */
				char * p = line + 1 ;
				switch ( toupper(*p) ) {
				case '[':
				case '(':
					t.use_rgb = 1;
					GetRGB( &p, &t.rgb );
					break;

				case 'B':	/* *Bpp */
					if ( toupper(p[1]) == 'P' && toupper(p[2]) == 'P' ) {
						int tempbps;
						p += 3;
						tempbps = 0;
						str_int( &p, &tempbps );
						switch ( tempbps ) {
						case 8:
							break;
						case 16:
						case 24:
						case 32:
							bHalftone = 1;
							break;
						default:
							tempbps = bps;
						}
						bps = tempbps;
					}
					break;

				case 'H':	/* *Halftone */
					bHalftone = 1;
					bRaw = 0;
					if ( !assign_halftone() ) {
						fprintf( message_handle, "Warning: n[tg[pbgݒł܂łB*Halftone擪sɈړāAȂׂłB\n" );
					}
					break;

				case 'R' :	/* *Raw */
					bRaw = 1;
					bHalftone = 0;
					break;
				case 'P' :	/* *Palette t@C */
					++p;
					if ( toupper(*p) == 'A' ) ++p;
					if ( toupper(*p) == 'L' ) ++p;
					if ( toupper(*p) == 'E' ) ++p;
					if ( toupper(*p) == 'T' ) ++p;
					if ( toupper(*p) == 'T' ) ++p;
					if ( toupper(*p) == 'E' ) ++p;
					SKIPSPACE(p);
					LoadPaletteFile(p);
					bRaw = 0;
					bHalftone = 0;
					break;

				case 'A': 	/* *Assign n [r,g,b] */
				  {
					int no = 0;
					RGBQUAD rgb;
					++p;
					if ( toupper(*p) == 'S' ) ++p;
					if ( toupper(*p) == 'S' ) ++p;
					if ( toupper(*p) == 'I' ) ++p;
					if ( toupper(*p) == 'G' ) ++p;
					if ( toupper(*p) == 'N' ) ++p;
					if ( *p != '[' ) {
						str_int( &p, &no );
						SKIPSPACE(p);
					}
					if ( GetRGB( &p, &rgb ) ) {
						no = assign_palette( rgb.rgbRed, rgb.rgbGreen, rgb.rgbBlue, no );
						SKIPSPACE(p);
						if ( *p ) {
							strupr(p);
							if ( bPascal ) {
								fprintf( hfp, "  DAR_%s = %d;\t/* palette (%3d,%3d,%3d) */\n", p, no, rgb.rgbRed, rgb.rgbGreen, rgb.rgbBlue );
							} else {
								fprintf( hfp, "#define DAR_%s\t%d\t\t/* palette (%3d,%3d,%3d) */\n", p, no, rgb.rgbRed, rgb.rgbGreen, rgb.rgbBlue );
							}
							if ( verbose == 1 ) {
								fprintf( message_handle, "\nDAR_%s %d RGB(%3d,%3d,%3d)", p, no, rgb.rgbRed, rgb.rgbGreen, rgb.rgbBlue );
							}
						}
					} else {
						fprintf( message_handle, "Warning: *Assign[r,g,b]w肪܂B܂B\n" );
					}
				  }
					break;

				case 'O' : 	/* *Offset x,y */
					++p;
					if ( *p == 'f' ) ++p;
					if ( *p == 'f' ) ++p;
					if ( *p == 's' ) ++p;
					if ( *p == 'e' ) ++p;
					if ( *p == 't' ) ++p;
					SKIPSPACE(p);
					size.ox = 0;
					size.oy = 0;
					str_signed_int( &p, &size.ox );
					SKIPSPACE(p);
					if ( *p == ',' ) ++p;
					str_signed_int( &p, &size.oy );
					break;

				case 'D' :	/* *Div */
					++p;
					if ( *p == 'i' ) ++p;
					if ( *p == 'v' ) ++p;
					size.dhei = 0;
					str_int( &p, &size.dhei );
					break;

				case 'Z' :	/* *Zoom */
					++p;
					if ( toupper(*p) == 'O' ) ++p;
					if ( toupper(*p) == 'O' ) ++p;
					if ( toupper(*p) == 'M' ) ++p;
					zoom = 1;
					str_int( &p, &zoom );
					break;

				default:
					/* * ͓pbgR[hw */
					t.use_rgb = 0;
					t.pal = -1;
					str_signed_int( &p, &t.pal ) ;
				}
			} else if ( line[0] == '%' ) {
				/*-------------
				   %n,n
				   %n+n,n+n
				   %/n,/n
				 */
				char * p = line + 1 ;
				memset( &size, 0, sizeof size );
				if ( *p == '/' ) {
					++p;
					str_int( &p, &size.div_wid );
				} else {
					str_int( &p, &size.wid ) ;
					if ( *p == '+' ) {
						++p;
						str_int( &p, &size.widBlank ) ;
					}
				}
				if ( *p == ' ' || *p == '\t' || *p == ',' ) {
					++p ;
					if ( *p == '/' ) {
						++p;
						str_int( &p, &size.div_hei );
					} else {
						str_int( &p, &size.hei ) ;
						if ( *p == '+' ) {
							++p;
							str_int( &p, &size.heiBlank ) ;
						}
					}
				} else {
					size.hei = size.wid ;
					size.heiBlank = size.widBlank;
				}
			} else if ( line[0] == ':' ) {
				/* :̓x */
				strupr(line);
				if ( bPascal ) {
					fprintf( hfp, "\n  DAR_%s = %u;\n\n", line+1, NumBitmaps );
				} else {
					fprintf( hfp, "\n#define DAR_%s (DAR_%s_BASE+%u)\n\n", line+1, fname, NumBitmaps );
				}
				if ( verbose == 1 ) {
					fprintf( message_handle, "\nDAR_%s #%d", line+1, NumBitmaps );
				}
			} else {
				/*---------------
				   s     bitmap filename
				 */
				if ( len > 1 ) {
					int nodef = 0;

					/* s '*' ̓wb_t@CɖOo͂Ȃw */
					if ( line[strlen(line)-1] == '*' ) {
						nodef = 1;
						line[strlen(line)-1] = 0;
					}

					/* O𒊏o */
					GetDefNamePart( defname, line );

					if ( !nodef ) {
						if ( bPascal ) {
							fprintf( hfp, "  DAR_%s = %u;\n", defname, NumBitmaps );
						} else {
							fprintf( hfp, "#define DAR_%s (DAR_%s_BASE+%u)\n", defname, fname, NumBitmaps );
						}
						if ( verbose == 1 ) {
							fprintf( message_handle, "\nDAR_%s #%d", defname, NumBitmaps );
						}
					} else {
						if ( verbose == 1 ) {
							fprintf( message_handle, "\n#%d", NumBitmaps );
						}
					}

					if ( !convert_image(line, size, t, bHalftone, zoom, nodef, hfp, bRaw, bps, outfp) ) {
						result = 1;
						break;
					}

					/* f[^ */
					size.ox = size.oy = size.dhei = 0;
				}
			}
		} /* if line[0] */
	} /* while fgets */

	if ( NumBitmaps > 0 ) {
		if ( bPascal ) {
			fprintf( hfp, "  TOTAL = %u;\n", NumBitmaps );
			fprintf( hfp, "Implementation\n"
				            "End.\n" );
		} else {
			fprintf( hfp, "#define DAR_%s_TOTAL %u\n", fname, NumBitmaps );
		}
		fprintf( message_handle, "\nTotal %d patterns\n"
				  "      %d colors\n"
				  "      %ld bytes on memory\n", NumBitmaps, numDefs - 1, TotalBytes );
		if ( numDefs > MAX_DEFS ) {
			fprintf( message_handle, "Warning: Too many colors!\n"
					"F̂ŋ߂FɊ蓖Ă܂Bn[tg[ɂꍇ͐ݒt@C̐擪 *HalftoneǉāAȂĂB\n" ) ;
		} else if ( numDefs < MAX_DEFS ) {
			int i = 0;
			fix_palette();
			do {
				/* XɍׂĂ䂭 */
				int g = (( i       & 1) << 2) + (((i >> 3) & 1) << 1) + ((i >> 6) & 1);
				int r = (((i >> 1) & 1) << 2) + (((i >> 4) & 1) << 1) + ((i >> 7) & 1);
				int b = (((i >> 2) & 1) << 2) + (((i >> 5) & 1) << 1) + ((i >> 8) & 1);
				assign_palette( r * 255/7, g * 255/7, b * 255/7, 0 ) ;
				++i ;
			} while ( numDefs < MAX_DEFS ) ;
		}
	}
	write_header(outfp);
	fclose(outfp);
	fclose(hfp);
	fclose(fp);
	if ( result ) {
		unlink(targetpath);
		unlink(headerfile);
	}
	return result;
}
